;;; This file is part of turtle, a turtle-graphics system for Scheme.

;;; Copyright (C) 2008  Luca Saiu

;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.

;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.

;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


;;; The length of a single dash:
(define dash-length 5)

;;; This procedure is just like "move", but it draws a *dashed* line
;;; instead of a solid line:
(define dashed-move-with-positive-argument
  (lambda (length)
    (let ((i 0)
          (is-pen-up #f))
      (while (< i length)
             (set! is-pen-up (not is-pen-up))
             (if is-pen-up
                 (pen-up)
                 (pen-down))
             (move dash-length)
             (set! i (+ i dash-length))
             ;; If we're making too long a line, go back
             (if (> i length)
                 (set! i (- length dash-length))))
      (pen-down))))

(define dashed-move
  (lambda (length)
    (if (> length 0)
        (dashed-move-with-positive-argument length)
        (begin
          (pen-up)
          (move length)
          (dashed-move-with-positive-argument (- length))
          (pen-up)
          (move length)
          (pen-down)))))
